
/* Copyright (C) 2002-2008 Free Software Foundation, Inc.
   Contributed by Andy Vaught

  This file is part of g95.

  G95 is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version.

  G95 is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with g95; see the file COPYING.  If not, write to
  the Free Software Foundation, 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.

  In addition to the permissions in the GNU General Public License, the
  Free Software Foundation gives you unlimited permission to link the
  compiled version of this file into combinations with other programs,
  and to distribute those combinations without any restriction coming
  from the use of this file.  (The General Public License restrictions
  do apply in other respects; for example, they cover modification of
  the file, and distribution when not linked into a combined executable.)
*/


#include "runtime.h"

/* hpux wants to call this function in main() for some reason */

#if FPU_HPPA
void __main(void) {}
#endif




/* main()-- Entry point for the fortran program */
void MAIN_(void);

int main(int argc, char *argv[]) {

/* Sometimes on x86, the stack isn't aligned to an 8-byte boundary,
 * which kills performance associated with doubles.  Align if
 * unaligned. */

#if HAVE_REAL_10 == 1 || HAVE_REAL_10 == 2
    asm("mov %%esp, %%eax\n"
	"and $0x04, %%eax\n"
	"sub %%eax, %%esp\n" : : : "%eax");
#endif

    g95_runtime_start(argc, argv);

    MAIN_();      /* Call the Fortran main program. */

    memory_done();
    g95_runtime_stop();

    return 0;
}
